#! /usr/bin/perl -W
# $Id: scheduler_keyword_to_xml.pl 3305 2005-01-12 09:15:50Z jz $

$script_name = "files_to_c++.pl";
$string_size = 15*4096;


sub file_to_cxx
{
    my $filename = shift;
    my $name     = shift;
    
    my $hex = "0123456789abcdef";
    
    print "const char $name" . "[] = \n";

    
    open FILE, "<$filename"  or die "$filename ist nicht lesbar";
    print "    \"";
    my $data;
    my $at_begin_of_line = 1;
        
    
    while( read( FILE, $data, $string_size ) )
    {            
        for( my $i = 0; $i < length( $data ); $i++ )
        {                    
            if( $trim  &&  $at_begin_of_line )
            { 
                if( $soft_trim   &&  substr( $data, $i, 1 ) eq ' ' )  { print " "; }
                while( $i < length( $data )  &&  substr( $data, $i, 1 ) eq ' ' ) { $i++; }
                if( $i < length( $data ) )  { $at_begin_of_line = 0; }
            }    
            
            my $c = substr( $data, $i, 1 );
            my $o = ord( $c );
            if( $o >= 0x20  &&  $o < 0x7F )
            {                      
                if( $c eq "\"" )
                {  
                    print "\\\"";
                }
                elsif( $c eq "\\" )
                {  
                    print "\\\\";
                }  
                else
                {
                    print $c;
                }
            }
            elsif( $o != 0x00 )
            {
                if( $c eq "\r" )
                {
                    print "\\r";
                }
                elsif( $c eq "\n" )
                {  
                    print "\\n\"\n    \"";  
                    $at_begin_of_line = 1;
                }
                else
                {
                    print "\\x" . substr( $hex, $o / 16, 1 ) . substr( $hex, $o % 16, 1 ) . "\" \"";
                }
            }
        }
    }

    print "\";\n\n";
    close FILE;
}



print "// \$" . "Id\$\n";
print "// ACHTUNG: NICHT AENDERN! DIESE DATEI IST GENENIERT VON $script_name\n";
print "\n";
print "\n";
print "\n";

my $rest = "struct Inline_files { const char* filename; const char* content; int length; };\n";
$rest .= "\n";
$rest .= "const Inline_files inline_files[] = \n";
$rest .= "{\n";

if( $ARGV[0] eq "-trim" )
{
    $trim = 1;
    shift;
}
elsif( $ARGV[0] eq "-soft-trim" )
{
    $trim = 1;
    $soft_trim = 1;
    shift;
}

foreach my $arg ( @ARGV )
{
    foreach my $filename ( glob( $arg ) )
    {
        $filename =~ s/\\/\//g;         # '\' => '/'
        my $name = $filename;
        $name =~ s/[^a-zA-Z0-9_]/_/g;
        $name = "file_$name";
    
        file_to_cxx( $filename, $name );
        
        $rest .= "    { \"$filename\", $name, sizeof $name - 1 },\n"; 
    }
}                       

$rest .= "    { NULL, NULL, 0 }\n";
$rest .= "};\n";

print $rest;
